var Rec43000_ParametroContasReceber_Controller = function(ScreenService, General, templateManager, Rec43000_ParametroContasReceber_Service){
    
    var self = this;
    
    self.afterLoadSource = function(widget){
        var data = widget.dataSource.data[0];
        var dataEmpty = {
            'CDAJACREREC':'',
            'CDAJACRERENEGO':'',
            'CDAJDESCREC':'',
            'CDAJDESCRENEGO':'',
            'CDAJMORAREC':'',
            'CDAJMULTAREC':'',
            'CDAJTXCARTCNAB':'',
            'CDGERALREC':'',
            'CDGROPERCNTR':'',
            'CDMOTIPROR':'',
            'CDTPBXRENEGO':'',
            'DSAJACREREC':'',
            'DSAJACRERENEGO':'',
            'DSAJDESCREC':'',
            'DSAJDESCRENEGO':'',
            'DSAJMORAREC':'',
            'DSAJMULTAREC':'',
            'DSAJTXCARTCNAB':'',
            'DSMOTIPROR':'',
            'DSTPBXRENEGO':'',
            'IDBLOQALTBOLREC':'N',
            'IDBLOQINCNTR':'',
            'IDCOMPCHQBAIXA':'S',
            'IDEXTELACALAJUBX':'B',
            'IDTPCNTRLIB':'',
            'IDUTBCOPREFCLIE':'N',
            'IDUTCTRLCANREMR':'',
            'IDUTLNFDEVOLREC':'N',
            'IDUTLPRORVCREC':'',
            'NRORG':'',
            'QTDIAANTBAIR':'',
            'QTDIAANTBOLR':'',
            'QTDIAANTLANR':'',
            'QTDIAAPOBAIR':'',
            'QTDIAAPOBOLR':'',
            'QTDIAAPOLANR':'',
            'IDEXCLAJBBXR':'N',
            'IDUTENVBOLAUTO':'N',
            'QTDIAANTENVBOL':'',
            'IDUTENVCARTAUTO':'N',
            'QTDIAPOSENVCAR':'',
            'CDTPBAIRENVBOL':'',
            'IDUTVISUBOLOPEL':'N',
            'CDOPEPERVISUBOL':'',
            'IDUTLPROCREC': '',
            'CDGRUPOPERCONT': '',
            'CDGRUPOPEREXCLUSAOBAIXA': '',
            'CDGRUPOPERCANREMBOL': '',
            'DSGROPERPROR': '',
            'IDCONTROLARECCONTRATO': '',
            'CDGROPERPROR':''
            
        };
        var dados = null;
        if (data) {
            dados = data;
            dados.__is_new = false;
            
            data.CDTPBAIRENVBOL_multi = data.CDTPBAIRENVBOL?data.CDTPBAIRENVBOL.split('_'):'';
            widget.getField('CDTPBAIRENVBOL_multi').reload();
            
            data.CDOPEPERVISUBOL_multi = data.CDOPEPERVISUBOL?data.CDOPEPERVISUBOL.split('_'):'';
            widget.getField('CDOPEPERVISUBOL_multi').reload();
            widget.redraw();
        }else{
            dados = dataEmpty;
            dados.__is_new = true;
        }
        
        widget.currentRow = dados;
        
        var intervaloDatasForm = templateManager.container.getWidget('intervaloDatasForm');
        intervaloDatasForm.currentRow.QTDIAANTLANR = dados.QTDIAANTLANR;
        intervaloDatasForm.currentRow.QTDIAAPOLANR = dados.QTDIAAPOLANR;
        intervaloDatasForm.currentRow.QTDIAANTBAIR = dados.QTDIAANTBAIR;
        intervaloDatasForm.currentRow.QTDIAAPOBAIR = dados.QTDIAAPOBAIR;
        intervaloDatasForm.currentRow.QTDIAANTBOLR = dados.QTDIAANTBOLR;
        intervaloDatasForm.currentRow.QTDIAAPOBOLR = dados.QTDIAAPOBOLR;
        
        var grupoOperadoresForm = templateManager.container.getWidget('grupoOperadoresForm');
        grupoOperadoresForm.currentRow.IDBLOQINCNTR = dados.IDBLOQINCNTR;
        grupoOperadoresForm.currentRow.CDGROPERPROR = dados.CDGROPERPROR;
        grupoOperadoresForm.currentRow.DSGROPERPROR = dados.DSGROPERPROR;
        grupoOperadoresForm.currentRow.IDTPCNTRLIB = dados.IDTPCNTRLIB;
        grupoOperadoresForm.currentRow.IDUTLPROCREC = dados.IDUTLPROCREC;
        grupoOperadoresForm.currentRow.DSGROPERCNTR = dados.DSGROPERCNTR;
        grupoOperadoresForm.currentRow.CDGROPERCNTR = dados.CDGROPERCNTR;
        grupoOperadoresForm.currentRow.IDUTLPRORVCREC = dados.IDUTLPRORVCREC;
        grupoOperadoresForm.currentRow.IDCONTROLARECCONTRATO = dados.IDCONTROLARECCONTRATO;
        grupoOperadoresForm.currentRow.DSGROPERRECCONTR = dados.DSGROPERRECCONTR;
        grupoOperadoresForm.currentRow.CDGROPERRECCONTR = dados.CDGROPERRECCONTR;
        grupoOperadoresForm.currentRow.IDUTCTRLCANREMR = dados.IDUTCTRLCANREMR;
        
        if(dados.CDGRUPOPERCONT != null){
            grupoOperadoresForm.currentRow.CDGRUPOPERCONT = dados.CDGRUPOPERCONT.split(",");
            grupoOperadoresForm.getField('CDGRUPOPERCONT').reload();
        }
        
        if(dados.CDGRUPOPEREXCLUSAOBAIXA != null){
            grupoOperadoresForm.currentRow.CDGRUPOPEREXCLUSAOBAIXA = dados.CDGRUPOPEREXCLUSAOBAIXA.split(",");
            grupoOperadoresForm.getField('CDGRUPOPEREXCLUSAOBAIXA').reload();
        }
        
        if(dados.CDGRUPOPERCANREMBOL != null){
            grupoOperadoresForm.currentRow.CDGRUPOPERCANREMBOL = dados.CDGRUPOPERCANREMBOL.split(",");
            grupoOperadoresForm.getField('CDGRUPOPERCANREMBOL').reload();
        }
        
        templateManager.updateTemplate();
    };

    self.saveTabeds = function(){
        var widgetsTabed = templateManager.container.getWidget('tabbedParametrosContasReceber').widgets;
        var rowsToSave   = [];
        
        widgetsTabed[0].currentRow.CDTPBAIRENVBOL  = widgetsTabed[0].currentRow.CDTPBAIRENVBOL_multi?widgetsTabed[0].currentRow.CDTPBAIRENVBOL_multi.join('_'):'';
        widgetsTabed[0].currentRow.CDOPEPERVISUBOL = widgetsTabed[0].currentRow.CDOPEPERVISUBOL_multi?widgetsTabed[0].currentRow.CDOPEPERVISUBOL_multi.join('_'):'';

        for (var i = 0; i < widgetsTabed.length; i++) {
            var widget = widgetsTabed[i];
            rowsToSave.push(widget.currentRow);
        }
        
        Rec43000_ParametroContasReceber_Service.saveWidgets(rowsToSave, rowsToSave[0].__is_new).then(function () {
            widgetsTabed[0].view();
            widgetsTabed[0].template = widgetsTabed[0].templateToView;
            widgetsTabed[1].view();
            widgetsTabed[1].template = widgetsTabed[1].templateToView;
            widgetsTabed[2].view();
            widgetsTabed[2].template = widgetsTabed[2].templateToView;
            widgetsTabed[0].reload();
            widgetsTabed[1].reload();
            widgetsTabed[2].reload();
            widgetsTabed[0].currentRow.__is_new = false;
            self.afterLoadSource(widgetsTabed[0]);
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    self.editMode = function(){
        var widgetsTabed = templateManager.container.getWidget('tabbedParametrosContasReceber').widgets;
        for (var i = 0; i < widgetsTabed.length; i++) {
            var widget = widgetsTabed[i];
            General.edit(widget);
            widget.template = widget.templateToForm;
        }
    };

    self.backToView = function(){
        var widgetsTabed = templateManager.container.getWidget('tabbedParametrosContasReceber').widgets;
        for (var i = 0; i < widgetsTabed.length; i++) {
            var widget = widgetsTabed[i];
            widget.view();
            widget.currentRow = widget.backupRow;
            widget.template = widget.templateToView;
        }
    };
    
    this.HabilitaCampos = function(widget) { 
        
        var grupoOperadoresForm = templateManager.container.getWidget('grupoOperadoresForm');
        
        var idbloqincntr =  grupoOperadoresForm.getField("IDBLOQINCNTR");
        var dsgropercntr = grupoOperadoresForm.getField("DSGROPERCNTR");
        var cdgropercntr = grupoOperadoresForm.getField("CDGROPERCNTR");
        var idtpcntrlib = grupoOperadoresForm.getField("IDTPCNTRLIB");
        
        var idutlprocrec = grupoOperadoresForm.getField("IDUTLPROCREC");
        var cdgroperpror = grupoOperadoresForm.getField("CDGROPERPROR");
        var dsgroperpror = grupoOperadoresForm.getField("DSGROPERPROR");
        
        
        var cdgrupopercont = grupoOperadoresForm.getField("CDGRUPOPERCONT");
        var idutlprorvcrec = grupoOperadoresForm.getField("IDUTLPRORVCREC");
        
        var idcontrolareccontrato  = grupoOperadoresForm.getField("IDCONTROLARECCONTRATO");
        var dsgroperreccontr = grupoOperadoresForm.getField("DSGROPERRECCONTR");
        var cdgroperreccontr = grupoOperadoresForm.getField("CDGROPERRECCONTR");
        
        var idutctrlcanremr  = grupoOperadoresForm.getField("IDUTCTRLCANREMR");
        var cdgrupopercanrembol = grupoOperadoresForm.getField("CDGRUPOPERCANREMBOL");
        
        
        if(idbloqincntr.value() == "S"){
            dsgropercntr.readOnly = false;
            idtpcntrlib.readOnly = false;
            dsgropercntr.validations.required =  true;
        } else{
            dsgropercntr.readOnly = true;
            idtpcntrlib.readOnly = true;
            dsgropercntr.setValue("");
            cdgropercntr.setValue("");
            idtpcntrlib.setValue("N");
            delete(dsgropercntr.validations.required);
        }
        
        if(idutlprocrec.value() == "S"){
          dsgroperpror.readOnly = false;
          dsgroperpror.validations.required =  true;
        }else{
          dsgroperpror.readOnly = true;
          dsgroperpror.setValue("");
          cdgroperpror.setValue("");
          delete(dsgroperpror.validations.required);
        }
        
        if(idutlprorvcrec.value() == "S"){
          cdgrupopercont.readOnly = false;
          cdgrupopercont.validations.required =  true;
        }else{
          cdgrupopercont.readOnly = true;
          cdgrupopercont.setValue("");
          delete(cdgrupopercont.validations.required);
        }
        
        if(idcontrolareccontrato.value() == "S"){
          dsgroperreccontr.readOnly = false;
          dsgroperreccontr.validations.required =  true;
        }else{
          dsgroperreccontr.readOnly = true;
          cdgroperreccontr.setValue("");
          dsgroperreccontr.setValue("");
          delete(dsgroperreccontr.validations.required);
        }
        
        if(idutctrlcanremr.value() == "S"){
          cdgrupopercanrembol.readOnly = false;
          cdgrupopercanrembol.validations.required =  true;
        }else{
          cdgrupopercanrembol.readOnly = true;
          cdgrupopercanrembol.setValue("");
          delete(cdgrupopercanrembol.validations.required);
        }
        grupoOperadoresForm.reload();
    };
    
    this.saveTabedsOperadores = function(widget){
        var dataSet = { row:widget.currentRow};
        
        if(widget.isValid()){
            Rec43000_ParametroContasReceber_Service.saveTabedsOperadores(dataSet).then(
                function(sucess) {
                ScreenService.showMessage('Grupo de Operadores salvo com sucesso!');
                widget.view();
                widget.reload();
            },
            function(callback){
                if(callback.data){
                    ScreenService.showMessage("Ocorreu um erro inesperado ao salvar o grupo de operadores");
                }
            }
            );
        }
    };
};
Configuration(function (ContextRegister){
    ContextRegister.register('Rec43000_ParametroContasReceber_Controller', Rec43000_ParametroContasReceber_Controller);
});